<?php
/*
* CSS Server status check MBot PHP script [ANSI]
* Russian language
*  2011 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
*/

/* CONFIGURATION */
define('SCRIPT_NAME',		'CSS Server status check');	// Script name.
define('SCRIPT_VERSION',	'1.0.0.5');					// Script version.
define('SYM_ENTER',			chr(0x0D).chr(0x0A));		// Enter
define('INCLUDE_PATH',		realpath('./') .'/mbot/scripts/include');
define('WORKING_PATH',		realpath('./') .'/mbot/scripts/autoload/CSSCheck');
define('SCRIPT_DEBUG',		false);						// Debug mode.
define('OUTPUT_ADV',		true);						// Show advanced server info.
define('OUTPUT_PLAYERS',	true);						// Show players list (if OUTPUT_ADV true).
/* END CONFIGURATION */

include (INCLUDE_PATH . '/conv.libphp4.php');
include (WORKING_PATH . '/CSSCheck_PHP4.php');

function mbot_load()
{ 
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon_miranda	= mb_IconLoadSkin(SKINICON_OTHER_MIRANDA);
		$icon_mbot		= 0;

		mb_SelfRegister(MB_EVENT_MENU_COMMAND, 1); 
		mb_SelfSetInfo('   CSS v.'. SCRIPT_VERSION .' by Dionys');
		mb_Echo('   CSS v.'. SCRIPT_VERSION .' .'. SYM_ENTER);
		mb_MenuAdd('  CSS', 0, 'GetServerCSS', $icon_mbot, 0x00);
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function GetServerCSS($param, $cid, $hmenu)
{ 
	$sv_list = file(WORKING_PATH .'/CSSCheck.txt');

	for ($i = 0; $i < count($sv_list); $i++)
	{
		if (SCRIPT_DEBUG)
		{
			mb_Echo(' '. $server_id[0] .':'. $server_id[1] . SYM_ENTER);
		}

		$server_id		= explode(':', trim($sv_list[$i]));
		$server_data	= GetServerData($server_id[0], $server_id[1]);

		if (OUTPUT_ADV)
		{
			$output	=								': '				. $server_data['SVDataName'].SYM_ENTER.
													': '			. $server_data['SVDataMode'].SYM_ENTER.
													': '			. $server_data['SVDataMap'].SYM_ENTER.
													': '			. $server_data['SVDataPing'].SYM_ENTER.
													': '			. $server_data['SVDataPlayers'] .'  '. $server_data['SVDataMPlayers'] . SYM_ENTER.
													': '			. $server_data['SVDataPassword'].SYM_ENTER.
													': '			. $server_data['SVDataVAC'].SYM_ENTER.
//													': '			. $server_data['SVDataVer'].SYM_ENTER.
													': '				. $server_data['SVDataSvType'].SYM_ENTER.
													'OS: '				. $server_data['SVDataSvOS'].SYM_ENTER.
													': '			. $server_data['SVDataStat'].SYM_ENTER;
			if (OUTPUT_PLAYERS)
			{
				$output .=							':'. SYM_ENTER . $server_data['PlayerList'];
			}
		}
		else
		{
			$output	=	': '				. $server_data['SVDataName']. SYM_ENTER .
						': '			. $server_data['SVDataMode']. SYM_ENTER .
						': '			. $server_data['SVDataMap']. SYM_ENTER .
						': '			. $server_data['SVDataPing']. SYM_ENTER .
						': '			. $server_data['SVDataPlayers'] .'  '. $server_data['SVDataMPlayers'] . SYM_ENTER;
		}

		mb_PUAdd(NULL, ' '. $server_id[0] .':'. $server_id[1], $output, 0, 0, mb_IconLoadSys(IDI_INFORMATION)); 
	}
}

function GetServerData($server_ip, $server_port)
{
	$query = new CServerInfo($server_ip, $server_port);

	$SrvInfo	= $query->getInfo();
	$SVDataPing	= $SrvInfo['ping'];
	$SVDataName	= $SrvInfo['hostname'];
	$SVDataMap	= $SrvInfo['map'];
	$SVDataGame	= $SrvInfo['gamename'];
	$SVDataMode	= $SrvInfo['gamedesc'];
	$SVDataPlayers	= $SrvInfo['numplayers'];
	$SVDataMPlayers	= $SrvInfo['maxplayers'];

	if ($SrvInfo['password'] == '1')
	{
		$SVDataPassword = '';
	}
	else
	{
		$SVDataPassword = '';
	}

	if ($SrvInfo['secure'] == '1')
	{
		$SVDataVAC = '';
	}
	else
	{
		$SVDataVAC = '';
	}

	if ($SrvInfo['dedicated'] == 'd')
	{
		$SVDataSvType = 'dedicated';
	}
	else
	{
		$SVDataSvType = 'listen';
	}

	if ($SrvInfo['os'] == 'w')
	{
		$SVDataSvOS = 'windows';
	}
	else if ($SrvInfo['os'] == 'l')
	{
		$SVDataSvOS = 'linux';
	}
	else
	{
		$SVDataSvOS = 'unix';
	}

	$PlrInfo	= $query->getPlayers();
	if ($SVDataPlayers == '0')
	{
		$SVDataStat = '';
		$PlayerList = ' '. SYM_ENTER .' ';
	}
	else
	{
		$SVDataStat	= '';
		$PlayerList	= '';
		$count		= count($PlrInfo);
		if ($count > 0)
		{
			for ($i = 0; $i < $count; $i ++)
			{
				$PlayerList	.= $PlrInfo[$i]['index'] .'. '. utf2ansi($PlrInfo[$i]['name']) .' Kills: '. $PlrInfo[$i]['kills'] .' InGame: '. $PlrInfo[$i]['time'] . SYM_ENTER;
			}
		}
	}

	$SVData['SVDataGame']		= $SVDataGame;
	$SVData['SVDataName']		= $SVDataName;
	$SVData['SVDataMode']		= $SVDataMode;
	$SVData['SVDataMap']		= $SVDataMap;
	$SVData['SVDataPlayers']	= $SVDataPlayers;
	$SVData['SVDataMPlayers']	= $SVDataMPlayers;
	$SVData['SVDataPassword']	= $SVDataPassword;
	$SVData['SVDataVAC']		= $SVDataVAC;
//	$SVData['SVDataVer']		= $SVDataVer;
	$SVData['SVDataSvType']		= $SVDataSvType;
	$SVData['SVDataSvOS']		= $SVDataSvOS;
	$SVData['SVDataPing']		= $SVDataPing;
	$SVData['SVDataStat']		= $SVDataStat;
	$SVData['PlayerList']		= $PlayerList;

	if (SCRIPT_DEBUG)
	{
		mb_Echo($SVDataGame.SYM_ENTER);
		mb_Echo($SVDataName.SYM_ENTER);
		mb_Echo($SVDataMode.SYM_ENTER);
		mb_Echo($SVDataMap.SYM_ENTER);
		mb_Echo($SVDataPlayers.SYM_ENTER);
		mb_Echo($SVDataMPlayers.SYM_ENTER);
		mb_Echo($SVDataPassword.SYM_ENTER);
		mb_Echo($SVDataVAC.SYM_ENTER);
//		mb_Echo($SVDataVer.SYM_ENTER);
		mb_Echo($SVDataSvType.SYM_ENTER);
		mb_Echo($SVDataSvOS.SYM_ENTER);
		mb_Echo($SVDataPing.SYM_ENTER);
		mb_Echo($SVDataStat.SYM_ENTER);
	}

	return $SVData;
}
?>